<?php
/* Copyright (C) 2001-2005 Rodolphe Quiedeville <rodolphe@quiedeville.org>
 * Copyright (C) 2004-2015 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) 2005-2012 Regis Houssin        <regis.houssin@inodbox.com>
 * Copyright (C) 2015      Jean-François Ferry	<jfefe@aternatik.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

/**
 *	\file       settlements/settlementsindex.php
 *	\ingroup    settlements
 *	\brief      Home page of settlements top menu
 */


// Load Dolibarr environment

$res = 0;
// Try main.inc.php into web root known defined into CONTEXT_DOCUMENT_ROOT (not always defined)
if (!$res && !empty($_SERVER["CONTEXT_DOCUMENT_ROOT"])) {
    $res = @include $_SERVER["CONTEXT_DOCUMENT_ROOT"] . "/main.inc.php";
}
// Try main.inc.php into web root detected using web root calculated from SCRIPT_FILENAME
$tmp = empty($_SERVER['SCRIPT_FILENAME']) ? '' : $_SERVER['SCRIPT_FILENAME'];
$tmp2 = realpath(__FILE__);
$i = strlen($tmp) - 1;
$j = strlen($tmp2) - 1;
while ($i > 0 && $j > 0 && isset($tmp[$i]) && isset($tmp2[$j]) && $tmp[$i] == $tmp2[$j]) {
    $i--;
    $j--;
}
if (!$res && $i > 0 && file_exists(substr($tmp, 0, ($i + 1)) . "/main.inc.php")) {
    $res = @include substr($tmp, 0, ($i + 1)) . "/main.inc.php";
}
if (!$res && $i > 0 && file_exists(dirname(substr($tmp, 0, ($i + 1))) . "/main.inc.php")) {
    $res = @include dirname(substr($tmp, 0, ($i + 1))) . "/main.inc.php";
}
// Try main.inc.php using relative path
if (!$res && file_exists("../main.inc.php")) {
    $res = @include "../main.inc.php";
}
if (!$res && file_exists("../../main.inc.php")) {
    $res = @include "../../main.inc.php";
}
if (!$res && file_exists("../../../main.inc.php")) {
    $res = @include "../../../main.inc.php";
}
if (!$res) {
    die("Include of main fails");
}

require_once DOL_DOCUMENT_ROOT . '/core/class/html.formfile.class.php';
require_once DOL_DOCUMENT_ROOT . '/user/class/usergroup.class.php';
require_once DOL_DOCUMENT_ROOT . '/custom/settlements/class/groupusers.class.php';
require_once DOL_DOCUMENT_ROOT . '/custom/settlements/class/helper.class.php';
require_once DOL_DOCUMENT_ROOT . '/custom/settlements/class/daily_closing.class.php';
require_once DOL_DOCUMENT_ROOT . '/custom/bbus/class/commissionhandler.class.php';
require_once DOL_DOCUMENT_ROOT . '/custom/financialreport/class/helper.class.php';
require_once DOL_DOCUMENT_ROOT . '/user/class/user.class.php';
require_once DOL_DOCUMENT_ROOT . '/custom/settlements/core/tpl/printPDF_szisz.php';

dol_include_once('/settlements/lib/settlements_group.lib.php');


$helper = new Helper($db);
$commmissionhandler = new CommissionHandler();
$userObj = new User($db);
$dailyClosing = new DailyClosing();

// Load translation files required by the page
$langs->loadLangs(array("financialreport@financialreport"));

$action = GETPOST('action', 'aZ09');
$id = GETPOST('id', 'int');
$user_id = GETPOST('user_id', 'int');
$idmenu = GETPOST('idmenu', 'int');
$confirmdailyclosing = GETPOST('confirmdailyclosing', 'int');
$confirmUnclosedDailyHistory = GETPOST('confirmUnclosedDailyHistory', 'int');

if ($confirmUnclosedDailyHistory) {
    $result = $dailyClosing->closeRecord($confirmUnclosedDailyHistory);
    if ($result > 0) {
        setEventMessage($langs->trans('SuccessfullyClosed'));
    }else{
        setEventMessage($langs->trans('NoClosed', 'error'));
    }
}


//print_r($_REQUEST);

$form = new Form($db);
$formfile = new FormFile($db);
$userObj = new User($db);

$result = $userObj->fetch($user_id);
$name = $userObj->firstname . ' ' . $userObj->lastname;
if (isset($userObj->array_options['options_nickname'])) {
    $name .= ' (' . $userObj->array_options['options_nickname'] . ')';
}

$isStatusClosed = $dailyClosing->getStatus($id);

if ($isStatusClosed) {
    $Block1stDataClosed = $dailyClosing->get1stBlocHistorykDataCLosed($id);
    $JSON = json_decode($Block1stDataClosed->dailyclosing_json);
}else{
    $packageHistoryRecordObj = $dailyClosing->get1stBlocHistorykDataOpen($id);
    if (!empty($packageHistoryRecordObj)) {
        $BLock2ndData = $helper->get2ndBlockData($packageHistoryRecordObj->package_id);
        $BLock3rdData = $helper->get3rdBlockDataHistory($packageHistoryRecordObj->package_entity, $user_id, $id);
        $factures = $helper->getAllFactures($packageHistoryRecordObj, $user_id);
        $addititonalDevices = $helper->getAddititonalDevices($packageHistoryRecordObj->id);
        $addititonalChangesDevices = $helper->getAddititonalChangesDevices($packageHistoryRecordObj->id);
    }
    $changeMoneyHUF = 0;
    $changeMoneyEUR = 0;
    $disabled = '';
}

if (isset($_REQUEST['withholding'])) {
    $deviceArray = $_REQUEST['withholding']['withholdingchk'];
    $amountArray = $_REQUEST['withholding']['withholdingAmount'];
    $problemWithForm = $helper->checkForm($deviceArray, $amountArray);

    if ($problemWithForm == false) {
        $resultDailyClosing = $helper->updatePackageHistoryFromHistory($id, $BLock3rdData);
        if ($resultDailyClosing < 0) {
            setEventMessage($langs->trans('dailyClosingFail'), 'errors');
        } else {
            $helper->returnDailyClosingHistoryWindowLocation($_SERVER["PHP_SELF"], $id, $user_id, $idmenu);
        }
    } else {
        setEventMessage($langs->trans('checklistFail'), 'errors');
    }
}

$title = '';
$help_url = '';
$morejs = '';
$morecss = '';

llxHeader('', $title, $help_url, '', 0, 0, $morejs, $morecss, '', 'classforhorizontalscrolloftabs');

print '<br>';

$linkback = '<a href="' . dol_buildpath("/custom/settlements/dailyclosing_list.php?user_id={$user_id}&idmenu={$idmenu}&mainmenu=settlements&leftmenu=", 1) . '">' . '<b><span class="fa fa-arrow-left"></span> ' . $langs->trans("BackToList") . '</b></a>';
print $linkback;

if ($isStatusClosed) {
    print '<div id="DCuserData" style="width: 100%, height:100%">';
    print '<table style="width:50%;">';
    include DOL_DOCUMENT_ROOT . '/custom/settlements/core/tpl/dailyclosing_json.tpl.php';
} else {
    include DOL_DOCUMENT_ROOT . '/custom/settlements/core/tpl/dailyclosing_open.tpl.php';
}
llxFooter();
$db->close();
?>

<style>
    .dailyClosingHeader {
        height: 80px;
        text-align: center;
        background-color: rgb(163, 0, 51);
        color: white;
        padding-top: 0px;
        border-radius: 10px;
    }

    .confirmButton {
        display: block;
        height: 40px;
        width: 100%;
        background-color: green;
        border: 1px solid darkgreen;
        border-radius: 5px;
        text-decoration: none;
        color: white;
        text-align: center;
        margin: auto;
        cursor: pointer;
    }

    .printbutton {
        display: block;
        padding-top: 10px;
        background-color: rgb(163, 0, 51);
        color: white !important;
        height: 30px;
        width: 250px;
        text-align: center;
        border: 1px solid grey;
        border-radius: 5px;
        text-decoration: none;
        white-space: nowrap;
    }
    .unprintedfactures {
        height: 40px;
        text-align: center;
        background-color: rgb(163, 0, 51);
        color: white;
        padding-top: 0px;
        border-radius: 10px;
        cursor: pointer;
    }

    .unprintedfacturetr {
        font-weight: bold;
    }
    .dailyclosingTableLeftSide {
        width: 100%;
    }

    .withholding{
        background-color: lightgrey;
    }
</style>
<script>
    $(document).ready(function () {

    });
    function showFactures(event) {
        const checkbox = event.target;
        const isChecked = checkbox.checked;
        if ($('#unprintedfactureslist').css('display') === 'none') {
            $('#unprintedfactureslist').css('display', 'inline-block');
            $('#unprintedFactureSpan').removeClass('fa-chevron-down');
            $('#unprintedFactureSpan').addClass('fa-chevron-up');
        } else {
            $('#unprintedFactureSpan').addClass('fa-chevron-down');
            $('#unprintedFactureSpan').removeClass('fa-chevron-up');
            $('#unprintedfactureslist').css('display', 'none');
        }
    }
    function checkall(event) {
        $('.inputfield').val('');
        var checkbox = event.target;
        if (checkbox.checked) {
            $('.DCcheckbox').prop('checked', true);
            $('.fields').css('display', 'none');
        } else {
            $('.DCcheckbox').prop('checked', false);
            $('.fields').css('display', 'inline-block');
        }
    }

    function checkboxClick(event) {
        const checkbox = event.target;
        const dataChkValue = checkbox.getAttribute("data-chk");
        const dataInputValue = checkbox.getAttribute("data-input");
        if (checkbox.checked) {
            $("#" + dataInputValue).val('');
            $("#" + dataChkValue).css('display', 'none');
        } else {
            $("#" + dataChkValue).css('display', 'inline-block');
        }
    }
</script>